# -*- encoding: utf-8 -*- 
require 'json'

module OpenDaum::Calendar
  class Base
    def initialize access_token
      @access_token = access_token
    end

    # {:name, :color, :description}
    def create_category attrs = {}
      @access_token.post '/calendar/category/create.json', {}
    end

    def categories
      res = @access_token.get '/calendar/category/index.json'
      JSON.parse(res.body).collect do |json|
        Category.new @access_token, json
      end
    end

    def events start_at = nil, end_at = nil, category_id = nil
      params = {
        :start_at => '2012-03-01',
        :end_at => '2012-07-01'
      }
      params.merge!(:category_id => category_id) if category_id
      url = "/calendar/event/index.json?" + params.to_param
      r = @access_token.get url
      JSON.parse(r.body).collect do |json|
        Event.new @access_token, json
      end
    end

  end

  class Category 
    attr_accessor :id, :name, :color, :description, :display_order

    def initialize access_token, attrs = {}
      @access_token = access_token
      attrs.each {|k, v| self.send("#{k}=", v) }
    end

    def create_event
    end

    def update attrs = {}
    end

    def events start_at = nil, end_at = nil
      puts "호출은 됐음"
    end

    def << event
    end

    def inspect
      "<\#캘린더:#{self.id}:#{self.name}:#{self.color}>"
    end
  end

  class Event 
    attr_accessor :id, :title, :category_id, :start_at, :end_at, :allday, :url, :description, :attach, :location, :uid, :repeat, :rrule, :exdates, :completed_at

    def initialize access_token, attrs = {}
      @access_token = access_token
      attrs.each {|k, v| self.send("#{k}=", v) }
    end

    def inspect
      "<\#일정:#{self.id}:#{self.title}:#{self.start_at}-#{self.end_at}>"
    end

  end

end
