require 'oauth'

module OpenDaum
  module Factory
    def calendar 
      Calendar::Base.new self
    end
  end

  class OAuth
    API_URL = 'https://apis.daum.net'

    @@default_options = {
      :site => API_URL,
      :request_token_path => '/oauth/requestToken',
      :access_token_path => '/oauth/accessToken'      
    }

    def initialize consumer_key, consumer_secret, options = {}
      @consumer = ::OAuth::Consumer.new consumer_key, consumer_secret, @@default_options.merge(options)    
    end
        
    def request_token callback_url
      @consumer.get_request_token :oauth_callback => callback_url
    end
    
    def get_access_token request_token, verifier
      token = @consumer.get_access_token request_token, :oauth_verifier => verifier    
      token.extend Factory
    end

    def access_token token, token_secret
      token = ::OAuth::AccessToken.new @consumer, token, token_secret
      token.extend Factory
    end

  end
end
